<?php

do_action( 'mobileview_functions_start' );

add_action( 'mobileview_theme_init', 'hipnews_init' );
add_action( 'mobileview_theme_language', 'hipnews_language' );
add_action( 'mobileview_post_head', 'mobileview_header_style' );
add_filter( 'mobileview_body_classes', 'hipnews_body_classes' );

// Functions from root-functions.php, don't want them changing the admin queries
add_filter( 'pre_get_posts', 'hipnews_exclude_categories' );
add_filter( 'pre_get_posts', 'hipnews_exclude_tags' );
add_filter( 'pre_get_posts', 'hipnews_search_filter' );

//--Device Theme Functions for HipNews --//

function hipnews_init() {

	$output_hipnews_scripts = apply_filters( 'hipnews_output_scripts', true );

	if ( $output_hipnews_scripts && !is_admin() ) {
	
		wp_enqueue_script( 'fitvids', MOBILEVIEW_URL . '/includes/js/fitvids.js', array( 'hipnews-js' ), mobileview_refreshed_files() );

		$minfile = MOBILEVIEW_DIR . '/themes/hipnews/iphone/js/theme.min.js';
		if ( file_exists( $minfile ) ) {
			wp_enqueue_script( 'hipnews-js', mobileview_get_bloginfo('template_directory') . '/js/hipnews.min.js', array( 'jquery-form' ), mobileview_refreshed_files() );
		} else {
			wp_enqueue_script( 'hipnews-js', mobileview_get_bloginfo('template_directory') . '/js/hipnews.js', array( 'jquery-form' ), mobileview_refreshed_files() );
		}

	if ( mobile_view_show_webapp_notice() ) {
		$minfile = MOBILEVIEW_DIR . '/includes/js/add2home.min.js';
		if ( file_exists( $minfile ) ) {
			wp_enqueue_script( 'add2home', MOBILEVIEW_URL . '/includes/js/add2home.min.js', array( 'hipnews-js' ), mobileview_refreshed_files() );
		} else {
			wp_enqueue_script( 'add2home', MOBILEVIEW_URL . '/includes/js/add2home.js', array( 'hipnews-js' ), mobileview_refreshed_files() );
		}
	}
    
    wp_enqueue_script( 'plugins-js', mobileview_get_bloginfo('template_directory') . '/js/plugins.js', array( 'jquery-form' ), mobileview_refreshed_files() );
    wp_enqueue_script( 'scripts-js', mobileview_get_bloginfo('template_directory') . '/js/scripts.js', array( 'plugins-js' ), mobileview_refreshed_files() ,'1.0.0', true);
    wp_enqueue_style( 'mmenu-css', mobileview_get_bloginfo('template_directory') . '/css/mmenu.css' );
    
}
		
function mobileview_header_style() {
	$settings = mobileview_get_settings();
	//$header_style = $settings->hipnews_header_color_style;
    if(!empty($header_style)){
	   //echo "<link rel='stylesheet' type='text/css' href='" . mobileview_get_bloginfo('template_directory') . "/css/". $header_style .".css?ver=" . mobileview_refreshed_files() . "' /> \n";
    }		
}

} //init

function hipnews_language( $locale ) {
	// In a normal theme a language file would be loaded here for text translation
}

function hipnews_body_classes( $body_classes ) {
	$settings = mobileview_get_settings();
	
	$is_idevice = strpos( $_SERVER['HTTP_USER_AGENT'],'iPad' ) || strpos($_SERVER['HTTP_USER_AGENT'],'iPhone' ) || strpos($_SERVER['HTTP_USER_AGENT'],'iPod' );

	$body_classes[] = $settings->hipnews_icon_type;
	

	$body_classes[] = $settings->hipnews_calendar_icon_bg;

	$body_classes[] = $settings->hipnews_text_justification;

	if ( $settings->hipnews_webapp_use_ajax ) {
		$body_classes[] = 'ajax-on';
	}

	if ( $settings->hipnews_webapp_status_bar_color == 'black-translucent' ) {
		$body_classes[] = $settings->hipnews_webapp_status_bar_color;
	}

	if ( $is_idevice ) {
		$body_classes[] = 'idevice';
	} else {
		$body_classes[] = 'generic';
	}

	if ( $is_idevice && is_iOS_5() ) {
		$body_classes[] = 'ios5';
	}

	if ( $settings->hipnews_enable_persistent ) {
		$body_classes[] = 'loadsaved';
	}

	return $body_classes;
}

// New logo code
function hipnews_mobile_has_logo() {
	$settings = mobileview_get_settings();
		if ( $settings->hipnews_header_img_location ) {
			return true;
		} else {
			return false;
		}
}

function hipnews_has_header_retina_image() {
	$settings = mobileview_get_settings();
	
	return apply_filters( 'hipnews_has_header_retina_image', ( $settings->hipnews_retina_header_img_location && strlen( $settings->hipnews_retina_header_img_location ) ) );
}

function hipnews_get_header_image_location() {
	$settings = mobileview_get_settings();
	
	if ( hipnews_has_header_retina_image() ) {
		return apply_filters( 'hipnews_header_image_location', $settings->hipnews_retina_header_img_location );
	} else {
		return apply_filters( 'hipnews_header_image_location', $settings->hipnews_header_img_location );
	}
}

function hipnews_mobile_logo_img() {
	if ( hipnews_has_header_retina_image() ) {
		echo "<img id='retina-custom-logo' src='" . hipnews_get_header_image_location() . "' alt='retina-logo-image' /> \n";
	} else {
		echo "<img id='custom-logo' src='" . hipnews_get_header_image_location() . "' alt='logo-image' /> \n";
	}
}

function hipnews_background() {
	$settings = mobileview_get_settings();
	return $settings->hipnews_background_image;
}
/*
function hipnews_mobile_show_site_icon() {
	$settings = mobileview_get_settings();
		if ( $settings->hipnews_show_header_icon ) {
			return true;
		} else {
			return false;		
		}
}
*/
function hipnews_mobile_has_menu_icon() {
	$settings = mobileview_get_settings();
	
	if ( $settings->hipnews_use_menu_icon ) {
		return true;
	} else {
		return false;
	}
}

function hipnews_mobile_hide_responses() {
	$settings = mobileview_get_settings();
	return $settings->hipnews_hide_responses;
}

function hipnews_mobile_com_toggle() {
	if ( !function_exists( 'id_activate_hooks' ) || !function_exists( 'dsq_is_installed' ) ) {
		$comment_string1 = __( 'No Comments Yet', "mobileviewlang" );
		$comment_string2 = __( '1 Comment', "mobileviewlang" );
		$comment_string3 = __( '% Comments', "mobileviewlang" );

		echo '<a id="comments-' . get_the_ID() . '" class="post no-ajax  com-toggle">';

		if ( hipnews_mobile_hide_responses() ) {
			echo '<img id="com-arrow" class="com-arrow" src="' . mobileview_get_bloginfo('template_directory') . '/images/com_arrow.png" alt="arrow" />';
		} else {
			echo '<img id="com-arrow" class="com-arrow-down" src="' . mobileview_get_bloginfo('template_directory') . '/images/com_arrow.png" alt="arrow" />';	
		}
		comments_number( $comment_string1, $comment_string2, $comment_string3 );
		echo '</a>';
	}
}

// Custom Comments
// Custom callback to list comments in the your-theme style
function hipnews_custom_comments( $comment, $args, $depth ) {
	$GLOBALS[ 'comment' ] = $comment;
	$GLOBALS[ 'comment_depth' ] = $depth;
  ?>
   <li id="comment-<?php comment_ID() ?>" <?php comment_class() ?>>
   	<div class="comment-entry">
	    <div class="comment-top">
	    	<?php hipnews_commenter_link() ?>
	    	<div class="comment-meta">
		    	<?php printf( __( '%1$s - %2$s <span class="meta-sep"></span>', "mobileviewlang" ),
					get_comment_date( 'M d' ), 
					get_comment_time() ); 
				?>
	    	</div>
	    	<div class="comment-buttons">
		    	<?php edit_comment_link( __( 'Edit', "mobileviewlang" ), ' <span class="edit-link">', '</span>' ); ?>
					<?php if ( !class_exists( 'wp_thread_comment' ) ) // echo the comment reply link
					if( $args[ 'type' ] == 'all' || get_comment_type() == 'comment' ) : comment_reply_link( 
						array_merge( 
							$args, array(
								'reply_text' => __( 'Reply',"mobileviewlang" ),
								'login_text' => __( 'Reply.',"mobileviewlang" ),
								'depth' => $depth
							)
						) 
					);
					endif; ?>
				</div>
				<?php if ( $comment->comment_approved == '0' ) __( "<span class='unapproved'>Your comment is awaiting moderation.</span>", "mobileviewlang" ) ?>
			</div>

			<div class="comment-content">
				<?php comment_text() ?>
			</div>
		</div>

<?php } // end custom_comments

// Produces an avatar image with the hCard-compliant photo class
function hipnews_commenter_link() {
	$commenter = get_comment_author_link();
	if ( preg_match( '/<a[^>]* class=[^>]+>/', $commenter ) ) {
		$commenter = preg_replace( '/(<a[^>]* class=[\'"]?)/', '\\1url ' , $commenter );
	} else {
		$commenter = preg_replace( '/(<a )/', '\\1class="url "/' , $commenter );
	}

	$avatar_email = get_comment_author_email();
	$avatar = str_replace( "class='avatar", "class='photo avatar", get_avatar( $avatar_email, 68 ) );
	echo $avatar . ' <span class="fn n">' . $commenter . '</span>';
} // end commenter_link

/*-----------------------------------------------------------------------------------*/	
/* Search Form*/
/*-----------------------------------------------------------------------------------*/
function hipnews_custom_search( $form ) {

	$form = '<form id="searchform" class="searchform" action="' . home_url( '/' ) . '">
					<div>
					<input type="text" class="search-field" name="s" id="s" placeholder="'.__("Search Here","colabsthemes").'..." value="'.get_search_query().'">
					<input id="searchsubmit" type="submit" value="Search" tabindex="2">
					</div>
					</form>';
    return $form;
}

add_filter( 'get_search_form', 'hipnews_custom_search' );
?>